{ inputs, withSystem, ... }:
let
  inherit (inputs.self.lib.my) mkSystem;
  inherit (inputs.self.lib) listToAttrs;

  mkSystem' = sys: {
    name = sys.hostname;
    value = mkSystem ({ inherit withSystem; } // sys);
  };
in
{
  flake.nixosConfigurations = listToAttrs [
    (mkSystem' {
      hostname = "marr";
      system = "x86_64-linux";
      extraModules = [ inputs.agenix.nixosModules.default ];
    })

    (mkSystem' {
      hostname = "brontes";
      system = "x86_64-linux";
      extraModules = [ inputs.agenix.nixosModules.default ];
    })

    (mkSystem' {
      hostname = "shan";
      system = "x86_64-linux";
      extraModules = [
        inputs.disko.nixosModules.disko
        inputs.agenix.nixosModules.default
      ];
    })

    (mkSystem' {
      hostname = "raptus";
      system = "x86_64-linux";
      extraModules = [
        inputs.disko.nixosModules.disko
        inputs.agenix.nixosModules.default
      ];
    })

    (mkSystem' {
      hostname = "nihilus";
      system = "aarch64-linux";
      extraModules = [ ];
    })
  ];
}
